Imports TIS.Imaging

Public Class Form1


    Dim SoftwareTrigger As TIS.Imaging.VCDButtonProperty
    Dim ExposureMode As TIS.Imaging.VCDMapStringsProperty
    Dim TriggerDelay As TIS.Imaging.VCDAbsoluteValueProperty
    Dim TriggerDebounceTime As TIS.Imaging.VCDAbsoluteValueProperty
    Dim TriggerMaskTime As TIS.Imaging.VCDAbsoluteValueProperty
    Dim TriggerNoiseSuppressionTime As TIS.Imaging.VCDAbsoluteValueProperty
    Dim TriggerBurstCount As TIS.Imaging.VCDRangeProperty
    Dim TriggerBurstInterval As TIS.Imaging.VCDRangeProperty
    Dim TriggerOverlap As TIS.Imaging.VCDMapStringsProperty
    Dim counter As Integer

    ''' <summary>
    ''' Form_Load
    '''
    ''' Initializes the buttons and sets the size of the control
    ''' to the size of the currently selected video format.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Check if a valid video capture device has been selected, otherwise
        ' show the device selection dialog of Imaging Control.



        If Not IcImagingControl1.DeviceValid Then
            IcImagingControl1.ShowDeviceSettingsDialog()

            counter = 0

            If Not IcImagingControl1.DeviceValid Then
                MessageBox.Show("No device was selected.", "Display Buffer Sample")
                Me.Close()
                Exit Sub
            End If

            SoftwareTrigger = IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_TriggerMode,
                                                    VCDGUIDs.VCDElement_SoftwareTrigger, VCDGUIDs.VCDInterface_Button)




            ExposureMode = IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_TriggerMode,
                                                Guid.Parse("B6E013CA-76C7-4DDD-9AC8-A17E07C5E3F1"),
                                                VCDGUIDs.VCDInterface_MapStrings)

            '//gK[Delay錾
            TriggerDelay = IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_TriggerMode,
                                                VCDGUIDs.VCDElement_TriggerDelay,
                                                VCDGUIDs.VCDInterface_AbsoluteValue)

            '//DebounceTime錾;
            TriggerDebounceTime = IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_TriggerMode,
                                                VCDGUIDs.VCDElement_TriggerDebounceTime,
                                                VCDGUIDs.VCDInterface_AbsoluteValue)

            '//MaskTime錾
            TriggerMaskTime = IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_TriggerMode,
                                                VCDGUIDs.VCDElement_TriggerMaskTime,
                                                VCDGUIDs.VCDInterface_AbsoluteValue)
            '//NoiseSuppressionTime錾
            TriggerNoiseSuppressionTime = IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_TriggerMode,
                                                VCDGUIDs.VCDElement_TriggerNoiseSuppressionTime,
                                                VCDGUIDs.VCDInterface_AbsoluteValue)

            '//BurstCount錾;
            TriggerBurstCount = IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_TriggerMode,
                                                Guid.Parse("B4109964-77E4-4AF3-ACA8-45BBAA861B5C"),
                                                VCDGUIDs.VCDInterface_Range)

            '//BurstInterval錾;
            TriggerBurstInterval = IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_TriggerMode,
                                                Guid.Parse("A9715AB3-69AE-454D-8DF5-7E06D87C109C"),
                                                VCDGUIDs.VCDInterface_Range)


            '//gK[Overlap錾
            TriggerOverlap = IcImagingControl1.VCDPropertyItems.Find(VCDGUIDs.VCDID_TriggerMode,
                                                Guid.Parse("7685BF04-C9C9-4AE2-BA69-1278B77F97F6"),
                                                VCDGUIDs.VCDInterface_MapStrings)



            IcImagingControl1.LiveDisplayDefault = False
            IcImagingControl1.DeviceTrigger = True 'gK[[hI

            IcImagingControl1.LiveCaptureLastImage = False  ' Do Not save an image On live Stop.
            IcImagingControl1.LiveDisplay = False 'Cu摜\Ȃ

            IcImagingControl1.Sink = New TIS.Imaging.FrameQueueSink(Function(img)
                                                                        Return ShowImage(img)
                                                                    End Function, New TIS.Imaging.FrameType(TIS.Imaging.MediaSubtypes.RGB32), 5)


        End If

        cmdStop.Enabled = False

    End Sub


    Private Sub cmdStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStart.Click
        IcImagingControl1.LiveStart()
        cmdStart.Enabled = False
        cmdStop.Enabled = True
    End Sub



    Private Sub cmdStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStop.Click
        cmdStart.Enabled = True
        cmdStop.Enabled = False
        IcImagingControl1.LiveStop()
    End Sub



    ''' 
    Function ShowImage(img As TIS.Imaging.IFrameQueueBuffer)

        Try
            IcImagingControl1.DisplayImageBuffer(img)
            '//obt@̓eJPEGt@CƂăfBXNɕۑ܂
            Dim filename As String = String.Format("test{0}.jpg", counter)
            img.SaveAsJpeg(filename, 70)
            counter = counter + 1


        Catch ex As System.Exception
            System.Diagnostics.Trace.WriteLine(ex.Message)
        End Try

        Return TIS.Imaging.FrameQueuedResult.ReQueue
    End Function


    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        SoftwareTrigger.Push()
    End Sub
End Class
